from plesk_mail_migrator.core.provider.base_provider import BaseProvider


# noinspection PyAbstractClass
class BackupProvider(BaseProvider):
    def do_backup_messages(self, account, dumper, exclude_message_ids):
        """Dump (backup) messages of specified mail account

        :param plesk_mail_migrator.core.entities.mail_account.MailAccount account:
            Mail account for which we should dump messages
        :param plesk_mail_migrator.core.dumps.dump_writer.DumpWriter dumper:
            Object capable of writing dumps
        :param list[str] exclude_message_ids:
            Messages to exclude when dumping. Check "How the tool works with message IDs" in README for details
        :rtype: list[str]
        """
        raise NotImplementedError()
